;
; attiny2313_tm1637.asm
;
; Created: 30.06.2020 14:09:01
; Author : verbkinm
;
; :	
;	     4-     TM1637,   ds1302. 		
;	  ,  .

.include "tn2313adef.inc"
.include "def_equ.inc"

;========================================================
;			   
;========================================================

.def	CONST_ZERO		= r0		;  

.def	timer0_counter	= r1		;   TIM0   
.def	timer0_counter_alarm_unlock	= r2	;    


.def	alarm			= r3		;   == 0,   == 1
.def	alarm_lock		= r4		;  ,  == 1,  == 0. 
									;    N-    ,    .

.def	clock_mode		= r20		;     ( == 0,    == 1,  == 2)
.def	mode			= r21		;   ,   
									; (   == 0,  == 1,  == 2,  == 3,  == 4, 
									;  == 5,  \ == 6,   == 7,   == 8,
									;       == 9)

.def	BYTE			= r22		;  \  \ ds1302


;========================================================
;			   EEPROM
;========================================================

.eseg								;   EEPROM
	.org	0x00					;    

;-------------------------       

bcd_alarm_hours:	.db		0x07	;     07:30
bcd_alarm_minutes:	.db		0x30

;========================================================
;				   RAM
;========================================================

.dseg								;   RAM
	.org	0x60					;    

;-------------------------       DS1302

bcd_seconds:	.byte	1			;
bcd_minutes:	.byte	1			;
bcd_hours:		.byte	1			;
bcd_day:		.byte	1			;
bcd_month:		.byte	1			;
bcd_week_day:	.byte	1			;
bcd_year:		.byte	1			;

;-------------------------       TM1637 

tm_s1:			.byte	1			;  
tm_s2:			.byte	1			;  

tm_m1:			.byte	1			;  
tm_m2:			.byte	1			;  

tm_h1:			.byte	1			;  
tm_h2:			.byte	1			;  

tm_d1:			.byte	1			;    
tm_d2:			.byte	1			;   

tm_mt1:			.byte	1			;  
tm_mt2:			.byte	1			;  

tm_wd1:			.byte	1			;    
tm_wd2:			.byte	1			;    

tm_y3:			.byte	1			;  
tm_y4:			.byte	1			;  

;--------------------------    !

tm_y1:			.byte	1			;  ,       
tm_y2:			.byte	1			;  ,       

tm_ah1:			.byte	1			;   
tm_ah2:			.byte	1			;   
tm_am1:			.byte	1			;   
tm_am2:			.byte	1			;   

;========================================================
;			   
;========================================================

.cseg		 						;    
	.org	0						;     

start:	

	.include "interrupts_vector.asm"
	.include "interrupts.asm"
	.include "initialization.asm"

	;--------------------------   ,   r0  Z

	clr		CONST_ZERO

	ldi		ZH, 0
	ldi		ZL, 2

	ldi		r17, 29					
	mov		r1, r17

	clear_reg:
		dec		r1
		breq	clear_reg_end
		st		Z+, CONST_ZERO
		rjmp	clear_reg
	clear_reg_end:	

	;--------------------------  RAM   

	ldi		ZL,	 0x60
	ldi		r17, 28					;   27  = 28     

	clear_ram:
		dec		r17
		breq	clear_ram_end
		st		Z+, CONST_ZERO
		rjmp	clear_ram
	clear_ram_end:	

	;--------------------------      (  )  TM1637

	ldi		ZH, high(tm_y1)
	ldi		ZL, low(tm_y1)

	ldi		r17, char_2
	st		Z+, r17
	ldi		r17, char_0
	st		Z+, r17

	;--------------------------     EEPROM     TM1637

	ldi		r17, bcd_alarm_hours
	rcall	EEPROM_read
	rcall	conv_ds1302_to_tm1637
	st		Z+, r16
	st		Z+, r15

	ldi		r17, bcd_alarm_minutes
	rcall	EEPROM_read
	rcall	conv_ds1302_to_tm1637
	st		Z+, r16
	st		Z, r15

	;--------------------------   .  Proteus      !!!

	ldi		BYTE, 0
	sbr		BYTE, 0x88

	rcall	TM1637_start
	rcall	TM1637_send_byte
	rcall	TM1637_stop

	;--------------------------    DS1302

	rcall  DS1302_read_package_data	;  DS1302 -    DS1302   
										 ;   (    ),      

	;--------------------------  DS1302 -      !

	ldi		BYTE, 0x8E
	rcall	DS1302_send_start
	rcall	DS1302_send_byte

	ldi		BYTE, 0x00

	rcall	DS1302_send_byte
	rcall	DS1302_send_stop	

	ldi		BYTE, 0x80
	rcall	DS1302_send_start
	rcall	DS1302_send_byte

	ldi		BYTE, 0x00

	rcall	DS1302_send_byte
	rcall	DS1302_send_stop	

	sei								;  

	;--------------------------      

	main:	 
		sleep
		rjmp	main

.include "alarm.asm"
.include "ds1302.asm"
.include "tm1637.asm"
.include "lib.asm"

;--------------------------     .    .

max_day_in_month:	.db		31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31
